#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_LIBCOST
#include <cost.h>
#endif

#ifdef	HAVE_TIME_H
#include <time.h>
#endif

#ifdef	HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef	HAVE_GD_H
#include <gd.h>
#endif

#ifdef	HAVE_GDFONTS_H
#include <gdfonts.h>
#endif

#ifdef	HAVE_GDFONTS_H
#include <gdfontt.h>
#endif

#include <strfunc.h>

#include "desire.h"
#include "ddraw.h"


struct custom_line lines[] = {
  { 0x606060, 0xf0f0f0, FIELD_SRC, 0xffffffff, FIELD_U1, -1, -1, NULL, 0 },	/* All */
  { 0x3030ff, -1, FIELD_IN, 0xffffffff, FIELD_U1, -1, -1, NULL, 0 },		/* In */
  { 0xff3030, -1, FIELD_OUT, 0xffffffff, FIELD_U1, -1, -1, NULL, 0 },		/* Out */
};

int
main(int ac, char **av) {
	struct desire_image_options *io;
	ctb_data *data;
	gdImagePtr im;
	int count;
	ctb_session *ctbs = NULL;
	char buf[1024];
	float fl;

	printf("Expires: %s\n", timetostr(time(NULL)-300,
		TFMT_RFC822 | TFMT_OLD822GMT));
#ifdef	HAVE_GDIMAGEPNG
	printf("Content-type: image/png\n\n");
#else
	printf("Content-type: image/gif\n\n");
#endif
	fflush(stdout);

	io=fill_desire_image_options(0);
	io->legend_factor = 1024;
	io->vertical_legend = strdup("KBytes per second");

	if(!io->comments)
		io->comments = sinit();

	if(!io->service || !(ctbs=ctb_open(NULL, io->service, io->file))) {
		data=NULL; count=0;
	} else {
		data=ctb_get(ctbs, &(io->range), &count);
	};

	if(count) {
		int dc;
		ctb_data *dt;

		for(dc = count, dt = data; dc; dt++, dc--) {
			dt->Src = dt->In + dt->Out;
		};
	};

#ifdef	HAVE_LIBCOST
if(io->costtype && !lc_init(NULL) && count) {
	double cI=0;
	char **cls=NULL;

	if(io->costclass)
		cls=charize(io->costclass);

	cI=lc_cost(data, count, sizeof(ctb_data),
		FIELD_TS, FIELD_IN, sizeof(int),
		0, io->costtype, cls);

	sprintf(buf, "Service costs %.2f$.", cI);
	sadd(io->comments, buf);
};
#endif

	im=ddraw(ctbs, data, count, lines,
		sizeof(lines)/sizeof(struct custom_line), io);

	sprintf(buf, "A: %quk", lines[0].all >> 10);
		gdImageString(im, gdFontSmall, 6, 95, buf, lines[0].foreColor);
	fl = lines[0].meaningful_points
		?(float)(lines[0].all >> 10)/lines[0].meaningful_points/io->inpixel:0;
	sprintf(buf, "   %0.2fk/s", fl);
		gdImageString(im, gdFontSmall, 6, 105, buf, lines[0].foreColor);

	sprintf(buf, "I: %quk", lines[1].all >> 10);
		gdImageString(im, gdFontSmall, 6, 115, buf, lines[1].foreColor);
	fl = lines[1].meaningful_points
		?(float)(lines[1].all >> 10)/lines[1].meaningful_points/io->inpixel:0;
	sprintf(buf, "   %0.2fk/s", fl);
		gdImageString(im, gdFontSmall, 6, 125, buf, lines[1].foreColor);

	sprintf(buf, "O: %quk", lines[2].all >> 10);
		gdImageString(im, gdFontSmall, 6, 135, buf, lines[2].foreColor);
	fl = lines[2].meaningful_points
		?(float)(lines[2].all >> 10)/lines[2].meaningful_points/io->inpixel:0;
	sprintf(buf, "   %0.2fk/s", fl);
		gdImageString(im, gdFontSmall, 6, 145, buf, lines[2].foreColor);

	if(isatty(1))
		fprintf(stderr, "[Image will be displayed here]\n");
	else {
#ifdef	HAVE_GDIMAGEPNG
		gdImagePng(im, stdout);
#else
		gdImageGif(im, stdout);
#endif
	}

	return 0;
};


