#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/stat.h>

#ifdef	HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef	HAVE_TIME_H
#include <time.h>
#endif

#ifdef	HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef	HAVE_NETDB_H
#include <netdb.h>
#endif

#ifdef	HAVE_FCNTL_H
#include <fcntl.h>
#endif

#include <strfunc.h>

#include <desire.h>

char buf[128];

char ipfrom[15];
char ipto[15];
int pckt;
int bytes;

time_t age = 0;

int readconfig();

#define	IFDRY	1
#define	STOP	2

typedef struct _nets {
	struct in_addr ip;
	struct in_addr mask;
	struct in_addr ipto;
	struct in_addr maskto;
	char *sys;
	unsigned int flags;
	unsigned int inb, outb;
	struct _nets *next;
} nets;

static	ctb_data	rec;

nets *net_head=NULL;

int sux(char *);

int main(int ac, char **av) {
	int s;
	FILE *fd;
	int z, l;
	struct in_addr ip1, ip2;
	nets *nh;
	int avs;
	char *host;
	time_t tloc;
	ctb_session *ctbs;

	time(&tloc);
	/*     inetd. */
	tloc-=5;

	if(ac != 2) sux("Usage: cistat <nas_hostname> [...]");

	if(!(ctbs=ctb_open(NULL, "traffic", NULL))) {
		fprintf(stderr, "Can't open DESIRE session.\n");
		exit(2);
	};
	readconfig();

	for(avs=1; avs < ac; avs++) {
		host=av[avs];

	s=rcmd(&host, 514, "root", "root", "cle ip acco", NULL);
	if(s == -1) sux("Connection could not be established.");
	while(read(s, buf, sizeof(buf)) > 0);
	s=rcmd(&host, 514, "root", "root", "sh ip acco che", NULL);
	if(s == -1) sux("Connection could not be established.");
	printf("Hostname: %s\n", host);

	fd=fdopen(s, "r+");
	if(!fd)
		sux("Can't fdopen().");

#define ADA     "Accounting data age is "
#define ADA_SIZE        sizeof(ADA)-1
#define ADAE     "Accounting data age exact "	/* IPCAD extension */
#define ADAE_SIZE        sizeof(ADAE)-1

	while(fgets(buf, sizeof(buf), fd)) {

		if(*buf != ' ') {
			if(strncmp(buf, ADA, ADA_SIZE) == 0) {
				age = 60 * strtol(buf + ADA_SIZE, NULL, 10);
				continue;
			};
			if(strncmp(buf, ADAE, ADAE_SIZE) == 0) {
				age = strtol(buf + ADAE_SIZE, NULL, 10);
				continue;
			};
			continue;
		};

		if(sscanf(buf, "%s %s %d %d\n", ipfrom, ipto, &pckt, &bytes)!=4)
			continue;

		if(!inet_aton(ipfrom, &ip1) || !inet_aton(ipto, &ip2))
			continue;

		printf("%s\t-> ", inet_ntoa(ip1));
		printf("%-15s: %-8d ( ", inet_ntoa(ip2), bytes);

		nh=net_head;
		z=0;
		while(nh) {
			l=0;
			if(z && (nh->flags & IFDRY)) {
				nh=nh->next;
				continue;
			};
			if((nh->ip.s_addr == (ip1.s_addr & nh->mask.s_addr)) &&
			nh->ipto.s_addr == (ip2.s_addr & nh->maskto.s_addr)) {
				nh->outb+=bytes;
				l=z=1;
			};
			if((nh->ip.s_addr == (ip2.s_addr & nh->mask.s_addr)) &&
			nh->ipto.s_addr == (ip1.s_addr & nh->maskto.s_addr)) {
				nh->inb+=bytes;
				l=z=1;
			};
			if(l) printf("%s ", nh->sys);

			if(l && (nh->flags & STOP)) break;
			nh=nh->next;
		};

		printf(")\n");
	};

	fclose(fd);
	printf("\n");

	nh=net_head;
	while(nh) {
		if(nh->inb || nh->outb) {
			printf("%s\t<->\t", inet_ntoa(nh->ip));
			printf("%s\t(%s)\t%d/%d\n",
			    inet_ntoa(nh->ipto), nh->sys, nh->inb, nh->outb);
		} else {
			nh=nh->next; continue;
		};

		if(ctb_chname(ctbs, nh->sys)) {
			fprintf(stderr, "Can't choose DESIRE name: cisco/%s. Ignored.\n",
				nh->sys);
			nh=nh->next; continue;
		};

		rec.TS=tloc;
		rec.In=nh->inb;
		rec.Out=nh->outb;
		rec.U1=age;

		if(ctb_add(ctbs, &rec))
			fprintf(stderr, "Can't add DESIRE data.\n");

		ctb_chname(ctbs, NULL);

		nh=nh->next;
	};

	};

	ctb_close(ctbs);

	return 0;
};


int
readconfig() {
	FILE *cf;
	char sip[80];
	char sip2[80];
	char sys[80];
	char oth[80];
	char *p;
	struct in_addr ip, ipto;
	struct in_addr mask, maskto;
	nets *nh;
	int sscnt;

	if(!(cf=fopen("/usr/local/etc/cistat.conf", "r")))
		sux("Can't read config.");

	while(fgets(buf, sizeof(buf), cf)) {
		if(buf[strlen(buf)-1] != '\n' || strlen(buf) > 80)
			sux("Invalid config!");
		if((p=strchr(buf, '#'))) *p=0;
		if((sscnt=sscanf(buf, "%s %s %s %s", sip, sip2, sys, oth)) < 3)
			continue;
		if(strlen(sys) > 40) sux("Too long system name.");
		if(strchr(sys, '/')) sux("Slashes in system name.");


		if( split_network(sip,
			(unsigned int *)&ip.s_addr, (unsigned int *)&mask.s_addr) ) {
			sux("Invalid ip/mask.");
		};

		if( split_network(sip2,
			(unsigned int *)&ipto.s_addr, (unsigned int *)&maskto.s_addr) ) {
			sux("Invalid ip/mask.");
		};

		printf("%s/", inet_ntoa(ip));
		printf("%s\t<-> ", inet_ntoa(mask));
		printf("%s/", inet_ntoa(ipto));
		printf("%s\t-> %s\n", inet_ntoa(maskto), sys);

		if((nh = net_head)) {
			while(nh->next) nh=nh->next;
			nh=nh->next=(nets *)calloc(1, sizeof(nets));
		} else {
			nh=net_head=(nets *)calloc(1, sizeof(nets));
		};

		nh->ip=ip;
		nh->mask=mask;
		nh->ipto=ipto;
		nh->maskto=maskto;
		nh->sys=strdup(sys);
		nh->next=NULL;

		if(sscnt > 3) {
			if(!strcmp(oth, "ifdry"))
				nh->flags|=IFDRY;
			else if(!strcmp(oth, "stop"))
				nh->flags|=STOP;
			else {
				fprintf(stderr, "%s: ", oth);
				sux("unknown token.");
			};
		};

	};

	printf("\n");

	if(!net_head) sux("Empty config.");


	fclose(cf);

	return 0;
};


int sux(char *s) {
	fprintf(stderr, "%s\n", s);
	exit(2);
};



