/* $Id: pg_pstat.c,v 1.1.1.1 2001/02/27 12:33:07 vlm Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <sysexits.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/stat.h>
#include <string.h>
#include <pwd.h>
#include <ctype.h>
#include <setjmp.h>
#include <signal.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef	HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef	HAVE_SYS_RESOURCE_H
#include <sys/resource.h>
#endif

#include <strfunc.h>

#include "desire.h"

#include "pg_pstat.h"

void
display_stats() {
#ifdef	HAVE_GETRUSAGE
	struct rusage rsg;
	float tmp;
#endif

	fprintf(stderr, "Stats are:\n"
	"  File size:\t%ld\n"
	"  Start from:\t%ld (%.2f%%)\n"
	"  Processed bytes:\t%ld (%.2f%%)\n"
	"  Lines processed:\t%ld\n"
	"  Lines converted:\t%ld (%.2f%%)\n"
	"  Incorrect lines:\t%ld (%.2f%%)\n"
	"  Compressed size:\t%ld (%.2f%%)\n",
	(long)file_size, (long)file_start,
	file_size?((float) file_start * 100 / file_size):((float)0),
	(long)(file_pos - file_start),
	((file_size - file_start) > 0)?((float)(file_pos - file_start) * 100 / (file_size - file_start)):((float)0),
		(long)linecount,
		(long)linesok, linecount?((float) linesok * 100 / linecount):((float)0),
		(long)lineserr, linecount?((float) lineserr * 100 / linecount):((float)0),
		(long)bytesctb, (file_pos - file_start)?((float)bytesctb * 100 / (file_pos-file_start)):((float)0)
	);


#ifdef	HAVE_GETRUSAGE
	if(getrusage(0, &rsg) == 0) {
		fprintf(stderr, "  Time spent:\n"
			"    User:\t%ld.%03lds\n"
			"    System:\t%ld.%03lds\n",
			rsg.ru_utime.tv_sec,
			(long)(rsg.ru_utime.tv_usec / 1000),
			rsg.ru_stime.tv_sec,
			(long)(rsg.ru_stime.tv_usec / 1000)
		);
		rsg.ru_utime.tv_sec += rsg.ru_stime.tv_sec;
		rsg.ru_utime.tv_usec += rsg.ru_stime.tv_usec;
		tmp = rsg.ru_utime.tv_sec + ((float)rsg.ru_utime.tv_usec / 1000000);
		if(tmp <= 0)
			tmp = 0.01;
		fprintf(stderr, "    Real:\t%.03fs\n", tmp);
		fprintf(stderr, "  Speed:\n"
			"    bytes/sec:\t%d (%.01fk/s)\n"
			"    lines/sec:\t%d\n",
			(int)((float)(file_pos - file_start) / tmp),
			((float)(file_pos - file_start) / tmp / 1024),
			(int)((float)linecount / tmp)
		);
	};
#endif

};
