
#ifndef	_REENTRANT
#define	_REENTRANT	1
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <math.h>
#include <syslog.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_TIME_H
#include <time.h>
#endif

#ifdef	HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef	HAVE_GD_H
#include <gd.h>
#endif

#ifdef	HAVE_GDFONTS_H
#include <gdfonts.h>
#endif

#ifdef	HAVE_GDFONTT_H
#include <gdfontt.h>
#endif

#ifndef	HAVE_LOGF
#define	logf(v)	((float)log( v ))
#endif

#ifndef	HAVE_EXPF
#define	expf(v)	((float)log( v ))
#endif

#include <strfunc.h>

#include "desire.h"

#include "ddraw.h"

char buf[1024];

char *months[]={"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", NULL};

#define	IMAGE_Y_OVERHEAD	9
#define	IMAGE_X_OVERHEAD	25

struct trig {
	int type;
	int value;
};

gdImagePtr ddraw(

	ctb_session *ctbs,
	ctb_data *data,
	int dataCount,
	struct custom_line *line,
	int lines,
	struct desire_image_options *io

) {

	gdImagePtr im;
	ctb_data *dt = data;
	int i;
	int dc, lc;	/* data & line count */
	int ESize;

	/* Colors */
	int b, w, gray, bgr, grayb, graybb, grayw, grayww;
	int back0, back1, back2;

	/* Image dimensions */
	int imageHeight, imageWidth;
	time_t tstart=0, tend=0;
	int pcount=0;
	int inpixel;
	int smooth = io->smooth;
	int area_width;
	char *s;

	tstart = io->range.from;
	tend = io->range.to;

	/* Trimming */
	if(io->trim && dataCount > 0) {
		time_t t;
		if((t = data->TS))
			tstart = t;
		if((t = (data + dataCount - 1)->TS))
			tend = t;
	}

	ESize = ctb_entry_size(ctbs);

	if(!io->comments)
		io->comments = sinit();

	s = ctb_description(ctbs);
	if(s && *s)
		sadd(io->comments, s);

	sprintf(buf, "%s - ",
		timetostr(io->range.from, TFMT_LOCAL | TFMT_CTIME));
	strcat(buf, timetostr(io->range.to, TFMT_LOCAL | TFMT_CTIME));
	sadd(io->comments, buf);


	if(io->image_width < (io->area_height + IMAGE_Y_OVERHEAD * 2))
		io->image_width = (io->area_height + IMAGE_Y_OVERHEAD * 2);
	if(io->image_width < 400)
		io->image_width = 400;

	/* Get the desired width */
	imageWidth = io->image_width;

	pcount = abs(tend - tstart) + 1;

	inpixel = pcount * smooth /	(imageWidth - IMAGE_X_OVERHEAD - io->left_offset);
	if(inpixel <= 0)
		inpixel = 1;
	imageWidth = (pcount * smooth) / inpixel + IMAGE_X_OVERHEAD + io->left_offset;

	if(imageWidth <= 400)
		imageWidth = 400;
	else
		while(imageWidth > io->image_width) {
			inpixel++;
			imageWidth = (pcount * smooth) / inpixel
				+ IMAGE_X_OVERHEAD + io->left_offset;
		};

	io->inpixel = inpixel;
	pcount = pcount / inpixel;

	io->image_width = imageWidth;

	area_width = pcount * smooth;

	/* Y dimensions */
	imageHeight = IMAGE_Y_OVERHEAD + 24
		+ (io->comments?(8 * (io->comments->count)):0)
		+ io->area_height;
	if(imageHeight < io->image_height)
		imageHeight = io->image_height;
	else
		io->image_height = imageHeight;

	/******************/
	/* Creating image */
	/******************/

	im = gdImageCreate(imageWidth, imageHeight);

	if(io->interlace || im->interlace)
		gdImageInterlace(im, 1);

	b = gdImageColorAllocate(im, 0, 0, 0);
	w = gdImageColorAllocate(im, 0xff, 0xff, 0xff);

	gdImageFilledRectangle(im, 0, 0, imageWidth, imageHeight, w);

	back2 = gdImageColorAllocate(im, 250, 250, 250);
	back1 = gdImageColorAllocate(im, 244, 244, 244);
	back0 = gdImageColorAllocate(im, 240, 240, 240);

	grayww = gdImageColorAllocate(im, 224, 224, 224);
	grayw = gdImageColorAllocate(im, 192, 192, 192);
	gray = gdImageColorAllocate(im, 128, 128, 128);
	grayb = gdImageColorAllocate(im, 96, 86, 86);
	graybb = gdImageColorAllocate(im, 64, 64, 64);
	bgr = gdImageColorAllocate(im, 50, 50, 50);

	/* Allocate vectors of points */
	for(i = 0; i < lines; i++) {
		line[i].points = (long long *)sf_calloc(pcount + 3,
			sizeof(*line[0].points));
		line[i].stack = (size_t *)sf_calloc(pcount + 3,
			sizeof(*line[0].stack));
		line[i].foreColor = gdImageColorAllocate(im,
			(line[i].foreColor & 0x00ff0000) >> 16,
			(line[i].foreColor & 0x00ff00) >> 8,
			(line[i].foreColor & 0xff)
			);
		if((line[i].fillColor & 0xff000000)) {
			line[i].fillColor = -1;
		} else {
			line[i].fillColor = gdImageColorAllocate(im,
				(line[i].fillColor & 0x00ff0000) >> 16,
				(line[i].fillColor & 0x00ff00) >> 8,
				(line[i].fillColor & 0xff)
				);
		};
	};

	gdImageFilledRectangle(im, io->left_offset,
		io->area_height/4 + IMAGE_Y_OVERHEAD,
		imageWidth-7,
		io->area_height + IMAGE_Y_OVERHEAD,
		back2);
	gdImageLine(im, io->left_offset-2,
		io->area_height/4 + IMAGE_Y_OVERHEAD,
		imageWidth-7,
		io->area_height/4 + IMAGE_Y_OVERHEAD,
		grayw);

	gdImageFilledRectangle(im, io->left_offset,
		io->area_height/2 + IMAGE_Y_OVERHEAD,
		imageWidth-7,
		io->area_height + IMAGE_Y_OVERHEAD,
		back1);
	gdImageLine(im, io->left_offset-2,
		io->area_height/2 + IMAGE_Y_OVERHEAD,
		imageWidth-7,
		io->area_height/2 + IMAGE_Y_OVERHEAD,
		grayw);

	gdImageFilledRectangle(im, io->left_offset,
		io->area_height*3/4 + IMAGE_Y_OVERHEAD,
		imageWidth-7,
		io->area_height + IMAGE_Y_OVERHEAD,
		back0);
	gdImageLine(im, io->left_offset-2,
		io->area_height*3/4 + IMAGE_Y_OVERHEAD,
		imageWidth-7,
		io->area_height*3/4 + IMAGE_Y_OVERHEAD,
		grayw);


	if(io->vertical_legend) {
		gdImageStringUp(im, gdFontTiny, 3, strlen(io->vertical_legend) * 5 + 5, io->vertical_legend, b);
	}


/* Drawing the image */

if(!dataCount) goto notdata;

/*************/
/* Main loop */
/*************/

{
  long long *points;
  size_t	*stack;
  struct line_filter *filter;

	/* Data */
  unsigned int dataOffset;
  unsigned int dataValue;
  unsigned int dataMask;

	/* Mask */
  unsigned int widthOffset;
  unsigned int widthMask;
  int widthSign;

	/* Filter */
  unsigned int filterOffset = 0;
  unsigned int filterMask = 0;
  unsigned int filterValue = 0;
  unsigned int filterRule = 0;

  unsigned int elmax = 0;
  long long all;

  int xnow, xend;
  int timeWidth;	/* Width of data chunk in pixels */


  /****************************************/
  /*** End of variables initialization ***/
  /**************************************/

	/* Pre-filtering */
	filter = io->optPreFilter;
  if(filter && filter->Offset < 0xffffff) {
	filterOffset = filter->Offset;
	filterMask = filter->Mask;
	filterValue = filter->Value;
	filterRule = filter->Rule;

	for(dc = dataCount, dt = data;
		dc;	
		dc--, ((char *)dt) += ESize) {
			if(filterOffset != (unsigned int)-1) {
				dataValue = (*(unsigned int *)((char *)dt + filterOffset));
				if((dataValue & filterMask) == filterValue) {
					if(filterRule == 0)
						*(time_t *)dt = 0;
				} else {
					if(filterRule != 0)
						*(time_t *)dt = 0;
				};
			}
			if(filter->optFilter)
				filter->optFilter(dt);
	}

  }

  if(io->optBlockPreFilter)
		io->optBlockPreFilter(ctbs, data, dataCount, io);

	/* Loop */

  for(lc = 0; lc < lines; lc++) {
  	points = line[lc].points;
  	stack = line[lc].stack;
  	filter = line[lc].optLineFilter;
  	dataOffset = line[lc].dataOffset;
  	dataMask = line[lc].dataMask;
  	widthOffset = line[lc].widthOffset;
  	widthMask = line[lc].widthMask;
  	widthSign = line[lc].widthSign;
	filterOffset = (unsigned int)-1;

	all = 0;

	if(filter && filter->Offset < 0xffffff) {
		filterOffset = filter->Offset;
		filterMask = filter->Mask;
		filterValue = filter->Value;
		filterRule = filter->Rule;
	};

	for(dc = dataCount, dt = data;
		dc;	
		dc--, ((char *)dt) += ESize) {

		if(*(time_t *)dt == 0)	/* Seems to be already filtered */
			continue;

		/* Data filter must be checked right here */
		if(filter) {
			if(filterOffset != (unsigned int)-1) {
				dataValue = (*(unsigned int *)((char *)dt + filterOffset));
				if((dataValue & filterMask) == filterValue) {
					if(filterRule == 0) continue;
				} else {
					if(filterRule != 0) continue;
				};
			};
			if(filter->optFilter) {
				filter->optFilter(dt);
				if(*(time_t *)dt == 0)	/* Seems to be filtered */
					continue;
			};
		};

		xnow = (*(time_t *)dt - tstart) / inpixel;

		/* Compute real width in pixels from width in seconds */
		if(widthOffset > 0)
			timeWidth =
				((*(int *)((char *)dt + widthOffset)) & widthMask)
				/ inpixel;
		else
			timeWidth = (-widthOffset) / inpixel;

		if(dataOffset)
			dataValue = (*(int *)((char *)dt + dataOffset)) & dataMask;
		else
			dataValue = 1;	/* Est' nechto */

		if( dataValue > elmax )
			elmax = dataValue;

		if(timeWidth > 1) {

			if(widthSign < 0) {
				xend = xnow - timeWidth;
				if(xend < 0) xend = 0;
			} else {
				xend = xnow + timeWidth;
				if(xend >= pcount) xend = pcount - 1;
			};

			if(xnow > xend) { i = xnow; xnow = xend; xend = i; };
			if(xnow < 0) { if(xend < 0) continue; xnow = 0; };
			if(xend >= pcount) { if(xnow >= pcount) continue; xend=pcount-1; };

			all += dataValue;
			/* Data value per pixel */
			dataValue = (dataValue + timeWidth - 1) / timeWidth;

			for(i = xnow; i < xend; i++) {
				points[i] += dataValue;
				stack[i]++;
			};

		} else {
			if(xnow < 0 || xnow >= pcount) continue;

			points[xnow] += dataValue;
			stack[xnow]++;
			all += dataValue;
		};

	};

	{
		long meaningful_points = 0;
		for(i = 0; i < pcount; i++)
			if(stack[i])
				meaningful_points++;
		line[lc].meaningful_points = meaningful_points;
	};

	line[lc].elmax = elmax;
	line[lc].all = all;

  };	/* for(lc = 0; lc < lines; lc++) */

};

/*##################*/
/* End of main loop */
/*##################*/


/******************************/
/* Compute normalizing factor */
/******************************/

  /* Search for maximum values */
  for(lc = 0; lc < lines; lc++) {
		long long *points = line[lc].points;
		long long max = 0;
		size_t *stack = line[lc].stack;
		size_t	stackmax = 0;
		long long all = 0;
		long long stackall = 0;

		for(i = 0; i < pcount; i++) {
			all += points[i];
			if(points[i] > max)
				max = points[i];

			stackall += stack[i];
			if(stack[i] > stackmax)
				stackmax = stack[i];
		};

		line[lc].stackmax = stackmax;
		line[lc].max = max;
		line[lc].all = all;

		if(!max) {
			line[lc].factor = 0;
		} else {
			if(io->logarithm) {
				float lmax = logf(max);
				if(lmax <= 0 || lmax > 1000000)
					line[lc].factor = 0;
				else
					line[lc].factor = (float)(io->area_height - 1) / lmax;
			} else {
				line[lc].factor = (float)(io->area_height - 1) / (float)max;
			};
		};

		if(line[lc].group == -1) continue;
		if(line[lc].factor == 0.0) continue;

		/* Combine into groups */
		for(i = 0; i < lc; i++) {
			if(line[i].group != line[lc].group) continue;
			if(line[i].group == -1) continue;
			if(line[i].factor == 0.0) continue;

			if(line[i].factor > line[lc].factor)
				line[i].factor = line[lc].factor;
			else
				line[lc].factor = line[i].factor;
		};

  };

/*#############################*/
/* End of computing the factor */
/*#############################*/


/*****************/
/* Draw the grid */
/*****************/

#define	Q	1
#define	H	2
#define	D	4
#define	M	8
#define	Y	16

{
	int group;
	float maxf = 0;
	struct tm tm;
	time_t now;
	int canbedrawn=0;	/* YMDH */
	time_t diff, newdiff;
	int x;
	int color;
	int min_diff = 0;
	long long legend_factor;
	struct trig trig = {0};

	if(io->legend_factor) {
		legend_factor = inpixel * io->legend_factor;
	} else {
		legend_factor = 1;
	};

	group = line[0].group;
	for(x = 0; x < lines; x++) {
		if(line[x].group != group)
			continue;
		if(line[x].max > maxf)
			maxf = line[x].max;
	}

	maxf = line[0].max;

	if(io->logarithm) {

		maxf = maxf?logf(maxf):0;

		sprintf(buf, "%0.2f ", expf(maxf) / legend_factor);
		gdImageString(im, gdFontSmall,
			io->left_offset - strlen(buf) * 6, IMAGE_Y_OVERHEAD/2, buf, bgr);
		sprintf(buf, "%0.2f ", expf(maxf * 3/4) / legend_factor);
		gdImageString(im, gdFontSmall,
			io->left_offset - strlen(buf) * 6, io->area_height/4 + 3, buf, bgr);
		sprintf(buf, "%0.2f ", expf(maxf / 2) / legend_factor);
		gdImageString(im, gdFontSmall,
			io->left_offset - strlen(buf) * 6, io->area_height/2 + 3, buf, bgr);
		sprintf(buf, "%0.2f ", expf(maxf/4) / legend_factor);
		gdImageString(im, gdFontSmall,
			io->left_offset - strlen(buf) * 6, io->area_height*3/4 + 3, buf, bgr);

	} else {

		maxf = maxf / legend_factor;

		sprintf(buf, "%0.2f ", maxf);
		gdImageString(im, gdFontSmall,
			io->left_offset - strlen(buf) * 6, IMAGE_Y_OVERHEAD/2, buf, bgr);
		sprintf(buf, "%0.2f ", maxf * 3/4);
		gdImageString(im, gdFontSmall,
			io->left_offset - strlen(buf) * 6, io->area_height/4 + 3, buf, bgr);
		sprintf(buf, "%0.2f ", maxf / 2);
		gdImageString(im, gdFontSmall,
			io->left_offset - strlen(buf) * 6, io->area_height/2 + 3, buf, bgr);
		sprintf(buf, "%0.2f ", maxf / 4);
		gdImageString(im, gdFontSmall,
			io->left_offset - strlen(buf) * 6, io->area_height*3/4 + 3, buf, bgr);

	};

	/******************************************************/
	/* Test the possibilities to draw various scale grids */
	/******************************************************/

	localtime_r(&tstart, &tm);
	now = mktime(&tm);
	tm.tm_year++;
	now = (mktime(&tm) - now) * smooth / inpixel;
	i = now - i;

	x = (imageWidth - IMAGE_X_OVERHEAD);
	if(i > 10 && i < x && (min_diff = i))
		canbedrawn |= Y;	/* Years */
	i = i / 12;
	if(i > 10 && i < x && (min_diff = i))
		canbedrawn |= M;	/* Months */
	i = i / 30;
	if(i > 15 && i < x && (min_diff = i))
		canbedrawn |= D;	/* Days */
	i = i / 24;
	if(i > 20 && i < x && (min_diff = i))
		canbedrawn |= H;	/* Hours */
	i = i / 15;
	if(i > 3 && i < x && (min_diff = i))
		canbedrawn |= Q;	/* Quarter hours */


	localtime_r(&tstart, &tm);

	diff = -1;

	*buf = 0;

	for(x = 0; x < area_width; x++) {
		now = tstart + x * inpixel / smooth;
		gmtime_r(&now, &tm);

		tm.tm_sec = 0;
		tm.tm_min -= (tm.tm_min % 15);
		if(!(canbedrawn & (H-1))) tm.tm_min = 0;
		if(!(canbedrawn & (D-1))) tm.tm_hour = 0;
		if(!(canbedrawn & (M-1))) tm.tm_mday = 1;
		if(!(canbedrawn & (Y-1))) tm.tm_mon = 0;

		newdiff = mktime(&tm);
		newdiff -= now;

		if(newdiff > diff && (diff = -1)) {
			localtime_r(&now, &tm);

			color = grayww;

			if(canbedrawn & H || canbedrawn & Q) {
				if((canbedrawn & Q) & (min_diff >= 10)) {
					if(trig.type != Q || trig.value != tm.tm_min) {
						if(tm.tm_min != 0) {
							sprintf(buf, "%02d:%02d", tm.tm_hour, tm.tm_min);
						} else {
							color = grayw;
							sprintf(buf, "%02d", tm.tm_hour);
						}
					}
				} else {
					if(trig.type != H || trig.value != tm.tm_hour) {
						trig.type = H;
						trig.value = tm.tm_hour;
						color = grayw;
						sprintf(buf, "%02d", tm.tm_hour);
					}
				};
			};

			if(canbedrawn & D) {
				if( (!(canbedrawn & (D-1)))
					|| ((canbedrawn & H) && (tm.tm_hour == 0))) {
					if(trig.type != D || trig.value != tm.tm_mday) {
						trig.type = D;
						trig.value = tm.tm_mday;
						color = gray;
						sprintf(buf, "%d", tm.tm_mday);
					}
				};
			};

			if(canbedrawn & M) {
				if( (!(canbedrawn & (M-1)))
					|| ((canbedrawn & D) && (tm.tm_mday == 1))){
					if(trig.type != M || trig.value != tm.tm_mon) {
						trig.type = M;
						trig.value = tm.tm_mon;
						color = grayb;
						sprintf(buf, "%s", months[tm.tm_mon]);
					}
				};
			};

			if(canbedrawn & Y) {
				if( (!(canbedrawn & (Y-1)))
					|| ((canbedrawn & M) && tm.tm_mon == 0)) {
					if(trig.type != Y || trig.value != tm.tm_year) {
						trig.type = Y;
						trig.value = tm.tm_year;
						color = graybb;
						sprintf(buf, "%04d", tm.tm_year + 1900);
					}
				};
			};

			gdImageLine(im, io->left_offset + x + 1, IMAGE_Y_OVERHEAD,
				io->left_offset + x + 1,
					io->area_height + IMAGE_Y_OVERHEAD + 3, color);

			if(!*buf)
				continue;

			i = x - 2*strlen(buf);
			if(i > area_width)
				i = area_width - 4*strlen(buf);
			if(i < 0) i = 0;

			gdImageString(im, gdFontTiny,
				io->left_offset + i + 1,
				io->area_height + IMAGE_Y_OVERHEAD + 5, buf,
				((color+2)>graybb)?graybb:(color+2));

			*buf = 0;

		};
		diff = newdiff;

	};

};


/***************************/
/* Draw the computed lines */
/***************************/

{
	gdPoint *gdpoints;
	gdpoints = (gdPoint *)sf_calloc(pcount + 2, sizeof(gdPoint));

  for(lc = 0; lc < lines; lc++) {
		long long *points = line[lc].points;
		size_t *stack = line[lc].stack;
		float factor = line[lc].factor;
		int bottom = io->area_height + IMAGE_Y_OVERHEAD;
		int x_offset = io->left_offset;
		float fl;


		gdpoints[0].y = bottom;
		if(io->logarithm) {
			if(points[0] > 0) {
				fl = logf(points[0]) * factor;
				if(fl < 1) fl = 1;
			} else {
				fl = 0.0;
			};
		} else {
			fl = points[0] * factor;
		};

		gdpoints[0].y -= fl;
		gdpoints[0].x = x_offset;

		if(io->logarithm) {
			for(i = 1; i <= pcount; i++) {
				if(points[i-1] > 0) {
					fl = logf(points[i-1]) * factor;
					if(fl < 1.0)
						fl = 1.0;
				} else {
					if(!stack[i-1] && stack[i])
					{
						fl = bottom - gdpoints[i-1].y;
					} else {
						fl = 0.0;
					}
				};
				gdpoints[i].y = bottom - fl;
				gdpoints[i].x = x_offset + (i-1) * smooth + 1;
			};
		} else {
			for(i = 1; i <= pcount; i++) {
				gdpoints[i].y = bottom;
				if(!stack[i-1] && stack[i])
				{
					/* From _ to - */
					gdpoints[i].y = gdpoints[i-1].y;
				}
				else
				{
					gdpoints[i].y -= points[i-1] * factor;
				}
				gdpoints[i].x = x_offset + (i-1) * smooth + 1;
			};
		};

		gdpoints[i].y = bottom;
		gdpoints[i].x = x_offset + (i-1) * smooth + 1;
		gdpoints[i+1].y = bottom;
		gdpoints[i+1].x = x_offset;

		if(line[lc].fillColor != -1)
			gdImageFilledPolygon(im, gdpoints, pcount + 3, line[lc].fillColor);

		gdImagePolygon(im, gdpoints, pcount + 3, line[lc].foreColor);
  };

		free(gdpoints);

};

notdata:

	/* Outer Box */
	gdImageRectangle(im, 0, 0, imageWidth-1, imageHeight-1, graybb);
	/* Inner box */
	gdImageRectangle(im, io->left_offset, 5, imageWidth-6, imageHeight-6, grayb);

	/* Top horizontal line */
	gdImageRectangle(im, io->left_offset - 2,
		IMAGE_Y_OVERHEAD,
		imageWidth-7,
		IMAGE_Y_OVERHEAD,
		gray);

	/* Horisontal line at the bottom of the picture */
	gdImageLine(im, io->left_offset + 1, io->area_height + IMAGE_Y_OVERHEAD,
		imageWidth-6, io->area_height + IMAGE_Y_OVERHEAD, graybb);

	/* Comments */
	if(io->comments) {

		for(i = 0; i < io->comments->count; i++) {
			gdImageString(im, gdFontTiny,
				io->left_offset + 5,
				io->image_height  - 8 * io->comments->count + i * 8 - 8,
				io->comments->list[i], b);
		};
	};

	return im;
};




