
#ifndef	_REENTRANT
#define	_REENTRANT	1
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef	HAVE_FCNTL_H
#include <fcntl.h>
#endif

#ifdef  HAVE_TIME_H
#include <time.h>
#endif

#ifdef 	HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef  HAVE_SYS_FILE_H
#include <sys/file.h>
#endif

#include "desire.h"
#include "ctbint.h"
#include "session.h"

#define	CTB_RETURN { free(filename); \
	fchdir(rememberdirfd); \
	close(rememberdirfd); \
	return -1; }

int
ctb_add(ctb_session *ctbsp, void *data) {
	register ctb_sess *ctbs = (ctb_sess *)ctbsp;
	char *filename;
	int  rememberdirfd;
	int fd;
	struct tm tm;

	/* Session is not prepared yet */
	if(!ctbs || !data)
		return -1;

  /* If not cached, open and remember */
  if(!ctbs->cache_add_name
	|| (*(time_t *)data > ctbs->cache_add_untiltime)
	|| strcmp(ctbs->cache_add_name, ctbs->name)) {

	if(ctbs->cache_add_name) {
		free(ctbs->cache_add_name);
		ctbs->cache_add_name=NULL;
	};
	if(ctbs->cache_add_fp) {
		fclose(ctbs->cache_add_fp);
		ctbs->cache_add_fp=0;
	};

	/* Remember current dir */
	rememberdirfd=open(".", O_RDONLY);

	/* Prepare folder */
	filename=(char *)_ctb_malloc(strlen(ctbs->folder)
		+ strlen(ctbs->name) + 16);
	sprintf(filename, "%s/%s", ctbs->folder, ctbs->name);

	if(chdir(filename)) {
		if(!*ctbs->name || mkdir(filename, 0755) || chdir(filename))
			CTB_RETURN;
	};

	localtime_r((time_t *)data, &tm);
	sprintf(filename, "%04d-%02d", tm.tm_year+1900, tm.tm_mon+1);
	if((fd=open(filename, O_RDWR | O_CREAT
#ifdef	O_EXLOCK
		| O_EXLOCK
#endif
		, 0644)) == -1) CTB_RETURN;

#ifndef	O_EXLOCK
#ifdef	HAVE_FCNTL
	{
		struct flock fl = { 0, 0, 0, F_WRLCK, SEEK_SET };
		fl.l_pid = getpid();
		fcntl(fd, F_SETLKW, fl);
	}
#endif	/* FCNTL */
#endif	/* O_EXLOCK */

	if(!(ctbs->cache_add_fp=fdopen(fd, "a+")))
		CTB_RETURN;

	ctbs->cache_add_name=_ctb_strdup(ctbs->name);

	free(filename);
	fchdir(rememberdirfd);
	close(rememberdirfd);

	/* Will stop when data timestamp cross the month line */
	tm.tm_sec=-1;
	tm.tm_min=0;
	tm.tm_hour=0;
	tm.tm_mday=1;
	tm.tm_mon++;
	ctbs->cache_add_untiltime=mktime(&tm);

	/* Remember last time stamp */
	ctbs->cache_add_lasttime=*(time_t *)data;
	if(fseek(ctbs->cache_add_fp, - ctbs->EntrySize, SEEK_END) == 0) {
		time_t tloc;
		if(fread(&tloc, sizeof(time_t), 1, ctbs->cache_add_fp) == 1)
			ctbs->cache_add_lasttime = tloc;
	};
};

	if(*(time_t *)data < ctbs->cache_add_lasttime)
		*(time_t *)data = ctbs->cache_add_lasttime;	/* "Monotonizing" */
	else
		ctbs->cache_add_lasttime = *(time_t *)data;

	fwrite(data, ctbs->EntrySize, 1, ctbs->cache_add_fp);

	return 0;
};



