
#ifndef	_REENTRANT
#define	_REENTRANT	1
#endif

#include <stdlib.h>
#include <string.h>
#include <sys/types.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_TIME_H
#include <time.h>
#endif

#ifdef	HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#include "desire.h"
#include "ctbint.h"

ctb_range *
ctb_fill_time(ctb_range *r, int how) {
	struct tm tm;

	if((how & 0x0f) > YEAR)
		return NULL;

	if(!r)
		r = _ctb_malloc(sizeof(ctb_range));

	memset(r, 0, sizeof(ctb_range));
	r->either = 2;
	r->simple_def = how;

	time(&r->to);
	localtime_r(&r->to, &tm);
	tm.tm_isdst = -1;

	switch(how & 0xf0) {
	case CURR:
		switch(how & 0x0f) {
			case HOUR:
				tm.tm_sec = tm.tm_min = 0;
				r->from = mktime(&tm);
				tm.tm_sec = -1;
				tm.tm_hour++;
				r->to = mktime(&tm);
				break;
			case DAY:
				tm.tm_sec = tm.tm_min = tm.tm_hour = 0;
				r->from = mktime(&tm);
				tm.tm_sec = -1;
				tm.tm_mday++;
				r->to = mktime(&tm);
				break;
			case WEEK:
				tm.tm_sec = tm.tm_min = tm.tm_hour = 0;
				r->from = mktime(&tm);
				r->from -= (tm.tm_wday?tm.tm_wday:7) * 86400;
				r->to = r->from + 7 * 86400;
				break;
			case MONTH:
				tm.tm_sec = tm.tm_min = tm.tm_hour = 0;
				tm.tm_mday = 1;
				r->from = mktime(&tm);
				tm.tm_sec = -1;
				tm.tm_mon++;
				r->to = mktime(&tm);
				break;
			case YEAR:
				tm.tm_sec = tm.tm_min = tm.tm_hour = 0;
				tm.tm_mday = 1;
				tm.tm_mon = 1;
				tm.tm_isdst = 0;
				r->from = mktime(&tm);
				tm.tm_sec = -1;
				tm.tm_year++;
				r->to = mktime(&tm);
				break;
		};
		break;
	case LAST:
		switch(how & 0x0f) {
			case HOUR:
				tm.tm_hour--;
				r->from =  mktime(&tm);
				break;
			case DAY:
				tm.tm_mday--;
				r->from =  mktime(&tm);
				break;
			case WEEK:
				tm.tm_mday -= 7;
				r->from =  mktime(&tm);
				break;
			case MONTH:
				tm.tm_mon--;
				r->from =  mktime(&tm);
				break;
			case YEAR:
				tm.tm_year--;
				r->from =  mktime(&tm);
				break;
		};
		break;
	case PREV:
		switch(how & 0x0f) {
			case HOUR:
				tm.tm_sec = tm.tm_min = 0;
				tm.tm_hour--;
				r->from = mktime(&tm);
				tm.tm_sec = tm.tm_min = 59;
				r->to = mktime(&tm);
				break;
			case DAY:
				tm.tm_sec = tm.tm_min = tm.tm_hour = 0;
				tm.tm_mday--;
				r->from = mktime(&tm);
				tm.tm_sec = tm.tm_min = 59;
				tm.tm_hour = 23;
				r->to = mktime(&tm);
				break;
			case WEEK:
				tm.tm_sec = tm.tm_min = tm.tm_hour = 0;
				r->from = mktime(&tm);
				r->from -= (7 + (tm.tm_wday?tm.tm_wday:7)) * 86400;
				r->to=r->from + 7*86400;
				break;
			case MONTH:
				tm.tm_sec = tm.tm_min = tm.tm_hour = 0;
				tm.tm_mday = 1;
				tm.tm_mon--;
				r->from = mktime(&tm);
				tm.tm_sec--;	
				tm.tm_mon++;
				r->to = mktime(&tm);
				break;
			case YEAR:
				tm.tm_sec = tm.tm_min = tm.tm_hour = 0;
				tm.tm_mday = 1;
				tm.tm_mon = 0;
				tm.tm_isdst = 0;
				tm.tm_year--;
				r->from = mktime(&tm);
				tm.tm_sec--;	
				tm.tm_year++;
				r->to = mktime(&tm);
				break;
		};
		break;
	default:
		free(r);
		return NULL;
	};

	return r;
};
