#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#ifndef	NO_INET
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#endif
#include <sys/time.h>

#include "desire.h"
#include "session.h"
#include "ctbint.h"

char *
ctb_format(ctb_session *ctbsp, const char *fmt, void *datap) {
	register ctb_sess *ctbs = (ctb_sess *)ctbsp;
	register ctb_data *data= (ctb_data *)datap;
	register char *f;
	register _ctb_sbuf *sb;
	
	if(!ctbs)
		return NULL;

	if(ctbs->EntrySize < sizeof(ctb_data))
		return "[Non-compatible entry size]\n";

	/* Initialize buffer */
	sb = _ctb_sbuf_init();

	if(!(f=(char *)fmt) || !data)
		return NULL;

while(1) {
	switch(*f) {
		case 0:
			goto ret;
		case '%':
			f++;
			switch(*f) {
				case 0:
					goto ret;
				case '%': _ctb_sbuf_add(sb, "%"); break;
				case 't': _ctb_sbuf_sprintf(sb, "%d", (int)data->TS); break;
				case 'T':
						_ctb_sbuf_sprintf(sb, "%s", ctime((time_t *)&data->TS));
						sb->buf[--sb->len] = 0;	/* truncate */
						break;
				case 'f': _ctb_sbuf_sprintf(sb, "%02x.%02x.%02x.%02x",
							data->FL.c.s1c1,
							data->FL.c.s1c2,
							data->FL.c.s2c1,
							data->FL.c.s2c2
						);
						break;
				case 'F': _ctb_sbuf_sprintf(sb, "%s",
								ctb_map(ctbsp, &data->FL, FIELD_FL));
						break;
				case 's': _ctb_sbuf_sprintf(sb, "%#x", data->Src); break;
				case 'd': _ctb_sbuf_sprintf(sb, "%#x", data->Dst); break;
				case 'S': _ctb_sbuf_sprintf(sb, "%s",
								ctb_map(ctbsp, &data->Src, FIELD_SRC));
						break;
#ifndef	NO_INET
						_ctb_sbuf_sprintf(sb, "%s",
						inet_ntoa(*(struct in_addr*)&data->Src));
						break;
#else
						_ctb_sbuf_sprintf(sb, "%u", data->Src); break;
#endif
				case 'D': _ctb_sbuf_sprintf(sb, "%s",
								ctb_map(ctbsp, &data->Dst, FIELD_DST));
						break;
#ifndef NO_INET
                        _ctb_sbuf_sprintf(sb, "%s",
                        	inet_ntoa(*(struct in_addr*)&data->Dst));
                        break;
#else
                        _ctb_sbuf_sprintf(sb, "%u", data->Dst); break;
#endif
				case 'i': _ctb_sbuf_sprintf(sb, "%#x", data->In); break;
				case 'o': _ctb_sbuf_sprintf(sb, "%#x", data->Out); break;
				case 'I': _ctb_sbuf_sprintf(sb, "%u", data->In/1024); break;
				case 'O': _ctb_sbuf_sprintf(sb, "%u", data->Out/1024); break;
				case '1': _ctb_sbuf_sprintf(sb, "%s",
								ctb_map(ctbsp, &data->U1, FIELD_U1));
							break;
				case '2': _ctb_sbuf_sprintf(sb, "%s",
								ctb_map(ctbsp, &data->U2, FIELD_U2));
							break;
				default:
					_ctb_sbuf_add(sb, "%");
					_ctb_sbuf_add2(sb, f, 1);
			};
			break;
		default:
			_ctb_sbuf_add2(sb, f, 1);
	};
	f++;
};


ret:
	if(ctbs->tmp_format_string)
		free(ctbs->tmp_format_string);
	ctbs->tmp_format_string = sb->buf;
	free(sb);
	return ctbs->tmp_format_string;

};

