#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include "desire.h"
#include "ctbint.h"
#include "session.h"

#ifdef	CTB_RETURN
#undef	CTB_RETURN
#endif

#define	CTB_RETURN { free(fname); fchdir(rememberdirfd); close(rememberdirfd); return (void *)_ctb_calloc(1, ctbs->EntrySize); }

void *
ctb_get(ctb_session *ctbsp, ctb_range *range, int *count) {
	register ctb_sess *ctbs = (ctb_sess *)ctbsp;
	char *fname;
	int  rememberdirfd;
	FILE *fp;
	struct tm *tm;
	struct stat sb;
	void *data;
	int datasize=1;
	int starty, startm, endy, endm;
	int cy, cm, cme;
	off_t startof, endof;
	int cnt;
	int tmp1, tmp2;

	/* Session not prepared yet */
	if(!count) return 0;
	if(!ctbs || !range) {
		*count=-1;
		return NULL;
	};

	if(range->either)
		if(  ((range->simple_def & 0x0f) < HOUR)
		  || ((range->simple_def & 0x0f) > YEAR)
		  || ((range->simple_def & 0xf0) < 0x00)
		  || ((range->simple_def & 0xf0) > 0x20)
		) {
			*count=-1; return NULL;
		}

	cnt=*count=0;

	/* Prepare folder */
	rememberdirfd=open(".", O_RDONLY);
	fname=(char *)_ctb_malloc(strlen(ctbs->folder) + strlen(ctbs->name) + 20);
	sprintf(fname, "%s/%s", ctbs->folder, ctbs->name);
	if(chdir(fname)) CTB_RETURN;

	if(range->from > range->to) {
		time_t tmp;
		tmp = range->to;
		range->to = range->from;
		range->from = tmp;
	};

	if(range->either == 1)
		ctb_fill_time(range, range->simple_def);

	if(range->either
	  && ((range->simple_def & 0xf0) == PREV || (range->simple_def & 0xf0) == CURR)
	  && ((range->simple_def & 0x0f) == MONTH || (range->simple_def & 0x0f) == YEAR)) {
		time_t tloc;

		time(&tloc);
		tm=localtime(&tloc);
		tm->tm_year+=1900;
		tm->tm_mon++;

		if(range->simple_def == (PREV | MONTH)) {
			tm->tm_mon--;
			if(!tm->tm_mon) { tm->tm_year--; tm->tm_mon=12; };
		};

		if(range->simple_def == (PREV | YEAR))
				tm->tm_year--;

		if((range->simple_def & 0x0f) == MONTH) {
			sprintf(fname, "%04d-%02d", tm->tm_year, tm->tm_mon);
			fp=fopen(fname, "r");
			if(!fp) CTB_RETURN;
			if(fstat(fileno(fp), &sb)) { fclose(fp); CTB_RETURN; };
			data=(void *)_ctb_malloc(cnt = sb.st_size);
			if(!data) exit(2);
			cnt = cnt / ctbs->EntrySize;
			fread(data, ctbs->EntrySize, cnt, fp);
			fclose(fp);
			free(fname);
			fchdir(rememberdirfd);
			close(rememberdirfd);
			*count=cnt;
			return data;
		};

		data=(void *)_ctb_malloc(ctbs->EntrySize);
		sprintf(fname, "%04d", tm->tm_year);
		if((fp=fopen(fname, "r"))) {
			if(fstat(fileno(fp), &sb)) fclose(fp);
			else {
            cnt=sb.st_size / ctbs->EntrySize;
	    if(datasize < cnt) {
	    	while(datasize < cnt) datasize <<= 2;
            	data=(void *)_ctb_realloc(data, datasize * ctbs->EntrySize);
	    };
			fread(data, ctbs->EntrySize, cnt, fp);
			fclose(fp);
			free(fname);
			fchdir(rememberdirfd);
			close(rememberdirfd);
			*count=cnt;
			return data;
		}};

		for(cm=1; cm<=12; cm++) {
			sprintf(fname, "%04d-%02d", tm->tm_year, cm);
			if(!(fp=fopen(fname, "r"))) continue;
			if(fstat(fileno(fp), &sb)) { fclose(fp); continue; };
			sb.st_size = sb.st_size / ctbs->EntrySize;
			cnt+=sb.st_size;
			if(datasize < cnt) {
		while(datasize < cnt) datasize <<= 2;
		data=(void *)_ctb_realloc(data, datasize * ctbs->EntrySize);
			};
			fread(data, ctbs->EntrySize, sb.st_size, fp);
			fclose(fp);
		};

		fchdir(rememberdirfd);
		close(rememberdirfd);
		free(fname);
		*count=cnt;
		return data;
	};

/****************************************/
/*** main procedure, date-independent ***/
/****************************************/

	tm=localtime((time_t *)&(range->from));
	starty=tm->tm_year+1900;
	startm=tm->tm_mon+1;
	tm=localtime((time_t *)&(range->to));
	endy=tm->tm_year+1900;
	endm=tm->tm_mon+1;

	data=(void *)_ctb_calloc(1, ctbs->EntrySize);

	for(cy=starty; cy <= endy; cy++) {
		sprintf(fname, "%04d", cy);
		if((fp=fopen(fname, "r"))) {
			if(fstat(fileno(fp), &sb)) { fclose(fp); continue; }

			startof=0;
			endof=sb.st_size;

			if(cy==starty)
				startof=ctb_findstart(fp, range->from,
					sb.st_size, ctbs->EntrySize);
			if(cy==endy)
				endof=ctb_findend(fp, range->to, sb.st_size, ctbs->EntrySize);

			tmp1 = (endof - startof) / ctbs->EntrySize;
			fseek(fp, startof, SEEK_SET);
			if(datasize < cnt + tmp1) {
		while(datasize < cnt + tmp1) datasize=datasize << 2;
		data=(void *)_ctb_realloc(data, datasize * ctbs->EntrySize);
			};
			tmp2=fread(data + cnt * ctbs->EntrySize,
				ctbs->EntrySize, tmp1, fp);
			cnt+=tmp2;
			fclose(fp);
			continue;
		};

		if(cy == endy)
			cme=endm;
		else
			cme=12;

		for(cm=(cy==starty)?startm:1; cm<=cme; cm++) {
			sprintf(fname, "%04d-%02d", cy, cm);
			if(!(fp=fopen(fname, "r"))) continue;
			if(fstat(fileno(fp), &sb)) { fclose(fp); continue; }

			startof=0;
			endof=sb.st_size;


			if(cy==starty && cm==startm)
				startof=ctb_findstart(fp, range->from,
					sb.st_size, ctbs->EntrySize);
			if(cy==endy && cm==endm)
				endof=ctb_findend(fp, range->to, sb.st_size, ctbs->EntrySize);

			tmp1 = (endof - startof) / ctbs->EntrySize;

			if(datasize < cnt + tmp1) {
				while(datasize < cnt + tmp1) datasize = datasize << 2;
				data=(void *)_ctb_realloc(data, datasize * ctbs->EntrySize);
			};
			fseek(fp, startof, SEEK_SET);

			while(tmp1 > 0) {
				tmp2=(tmp1>1000000)?1000000:tmp1;
				tmp2=fread(data + cnt * ctbs->EntrySize,
					ctbs->EntrySize, tmp2, fp);
				if(tmp2 <= 0) break;
				cnt+=tmp2;
				tmp1-=tmp2;
			};

			fclose(fp);

		}; /* for(month) */
	}; /* for(years) */

	fchdir(rememberdirfd);
	close(rememberdirfd);

	*count=cnt;
	return data;
};


/**********************/
/* Service procedures */
/**********************/

off_t ctb_findstart(FILE *fp, time_t from, off_t fsize, int EntrySize) {
	time_t start, end, curt;
	off_t startof, endof, curof=-1, co;

	startof=0;
	endof=(fsize/EntrySize - 1) * EntrySize;

	/* fill start and end */
	fseek(fp, 0, SEEK_SET);
	fread(&start, sizeof(time_t), 1, fp);
	fseek(fp, endof, SEEK_SET);
	fread(&end, sizeof(time_t), 1, fp);

	if(from <= start) return 0;
	if(from > end) return fsize;

while(1) {

	co=curof;
	curof = (( startof + ((endof-startof) * (from - start)) / (end-start) ) >> 5) << 5;
	if(co==curof)
		while(1) {
			fseek(fp, curof, SEEK_SET);
			if(fread(&curt, sizeof(time_t), 1, fp) < 1) return curof;
			if(curt >= from) return curof;
			curof+=EntrySize;
		};

	fseek(fp, curof, SEEK_SET);
	fread(&curt, sizeof(time_t), 1, fp);

	if(curt == from) return curof;
	if(curt < from) { startof=curof; start=curt; }
	else { endof=curof; end=curt; };

	if(endof - startof == EntrySize)
		return endof;

};

};


off_t ctb_findend(FILE *fp, time_t till, off_t fsize, int EntrySize) {
	time_t start, end, curt;
	off_t startof, endof, curof=-1, co;

	startof=0;
	endof=(fsize/EntrySize - 1) * EntrySize;

	/* fill start and end */
	fseek(fp, 0, SEEK_SET);
	fread(&start, sizeof(time_t), 1, fp);
	fseek(fp, endof, SEEK_SET);
	fread(&end, sizeof(time_t), 1, fp);

	if(till <= start) return 0;
	if(till > end) return fsize;

while(1) {

	co=curof;
	curof = (( startof + ((endof-startof) * (till - start)) / (end-start) ) >> 5) << 5;
	if(co==curof)
		while(1) {
			fseek(fp, curof, SEEK_SET);
			if(fread(&curt, sizeof(time_t), 1, fp) < 1) return curof;
			if(curt > till) return curof;
			curof+=EntrySize;
		};
		
	fseek(fp, curof, SEEK_SET);
	fread(&curt, sizeof(time_t), 1, fp);

	if(curt == till) return curof + EntrySize;
	if(curt < till) { startof=curof; start=curt; }
	else { endof=curof; end=curt; };

	if(endof - startof == EntrySize) return endof;

};

};
