#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void *
_ctb_malloc(size_t size) {
	register void *ptr;

	ptr = malloc(size);
	if(!ptr) {
		fprintf(stderr, "Can't allocate memory in DESIRE.\n");
		abort();
	};

	return ptr;
};

void *
_ctb_calloc(size_t nmemb, size_t size) {
	register void *ptr;

	ptr = calloc(nmemb, size);
	if(!ptr) {
		fprintf(stderr, "Can't allocate memory in DESIRE.\n");
		abort();
	};

	return ptr;
};

void *
_ctb_realloc(void *p, size_t size) {
	register void *ptr;

	ptr = realloc(p, size);
	if(!ptr) {
		fprintf(stderr, "Can't allocate memory in DESIRE.\n");
		abort();
	};

	return ptr;
};

char *
_ctb_strdup(const char *str) {
	register char *ptr;

	if(!str)
		return NULL;

	ptr = strdup(str);
	if(!ptr) {
		fprintf(stderr, "Can't allocate memory in DESIRE.\n");
		abort();
	};

	return ptr;
};

char *
_ctb_strndup(const char *str, size_t nchars) {
	register char *ptr;

	if(!str)
		return NULL;

	ptr = (char *)malloc(nchars + 1);
	if(!ptr) {
		fprintf(stderr, "Can't allocate memory in DESIRE.\n");
		abort();
	};

	memcpy(ptr, str, nchars);
	ptr[nchars] = 0;

	return ptr;
};



