#ifndef	__SESSION_H__
#define __SESSION_H__

#include <stdio.h>

#include <sys/types.h>

#include <limits.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_DBOPEN

#ifdef	HAVE_DB_H
#include <db.h>
#endif

typedef	DB	DBMAP;
typedef DBT	DBCHUNK;
#define	map_data data
#define	map_size size

#else	/* HAVE_DBOPEN */
#ifdef	HAVE_DBM_OPEN

#ifdef	HAVE_NDBM_H
#include <ndbm.h>
#endif

typedef	DBM	DBMAP;
typedef datum DBCHUNK;
#define	map_data dptr
#define	map_size dsize

#endif
#endif

#ifndef CONFIG
#define CONFIG "/usr/local/etc/desire.conf"
#endif

#include "desire.h"

typedef struct {
	int off_start;
	int off_len;
} twooffsets;

typedef struct _ctb_map {
	int off_start;	/* 0 till EntrySize - 1 */
	int off_len;	/* 1, 2, 3, 4 */

	ssize_t nentries;
	ssize_t lastindex;

	char	*mapfile;

	DBMAP *dbf;
	int	OpenedReadOnly;

	struct _ctb_map *next;
} _ctb_map;

typedef struct {
	int ready;

	char *folder;
	char *service;
	char *name;
	char *description;

	size_t	EntrySize;	/* 32 */

	char *cache_add_name;
	FILE *cache_add_fp;
	time_t cache_add_untiltime;
	time_t cache_add_lasttime;

	_ctb_map *maps;

	char *tmp_format_string;
} ctb_sess;

#endif
